# Interface SnpSiftVisitor<T>

Type Parameters:
  `T` - The return type of the visit operation. Use `Void` for operations with no return type.

All Superinterfaces:
  `org.antlr.v4.runtime.tree.ParseTreeVisitor<T>`

All Known Implementing Classes:
  `SnpSiftBaseVisitor`

public interface SnpSiftVisitor<T> extends org.antlr.v4.runtime.tree.ParseTreeVisitor<T>
This interface defines a complete generic visitor for a parse tree produced by `SnpSiftParser`.

## Method Summary

Modifier and Type
Method
Description
`T`
`visitCompilationUnit(SnpSiftParser.CompilationUnitContext ctx)`
Visit a parse tree produced by `SnpSiftParser.compilationUnit()`.
`T`
`visitExpressionComp(SnpSiftParser.ExpressionCompContext ctx)`
Visit a parse tree produced by the `expressionComp` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitExpressionCond(SnpSiftParser.ExpressionCondContext ctx)`
Visit a parse tree produced by the `expressionCond` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitExpressionExists(SnpSiftParser.ExpressionExistsContext ctx)`
Visit a parse tree produced by the `expressionExists` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitExpressionLogic(SnpSiftParser.ExpressionLogicContext ctx)`
Visit a parse tree produced by the `expressionLogic` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitExpressionParen(SnpSiftParser.ExpressionParenContext ctx)`
Visit a parse tree produced by the `expressionParen` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitExpressionPlus(SnpSiftParser.ExpressionPlusContext ctx)`
Visit a parse tree produced by the `expressionPlus` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitExpressionSet(SnpSiftParser.ExpressionSetContext ctx)`
Visit a parse tree produced by the `expressionSet` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitExpressionTimes(SnpSiftParser.ExpressionTimesContext ctx)`
Visit a parse tree produced by the `expressionTimes` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitExpressionUnary(SnpSiftParser.ExpressionUnaryContext ctx)`
Visit a parse tree produced by the `expressionUnary` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitFunctionCall(SnpSiftParser.FunctionCallContext ctx)`
Visit a parse tree produced by the `functionCall` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitLiteralBool(SnpSiftParser.LiteralBoolContext ctx)`
Visit a parse tree produced by the `literalBool` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitLiteralFloat(SnpSiftParser.LiteralFloatContext ctx)`
Visit a parse tree produced by the `literalFloat` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitLiteralIndex(SnpSiftParser.LiteralIndexContext ctx)`
Visit a parse tree produced by the `literalIndex` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitLiteralInt(SnpSiftParser.LiteralIntContext ctx)`
Visit a parse tree produced by the `literalInt` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitLiteralString(SnpSiftParser.LiteralStringContext ctx)`
Visit a parse tree produced by the `literalString` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitVarReference(SnpSiftParser.VarReferenceContext ctx)`
Visit a parse tree produced by the `varReference` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitVarReferenceList(SnpSiftParser.VarReferenceListContext ctx)`
Visit a parse tree produced by the `varReferenceList` labeled alternative in `SnpSiftParser.expression()`.
`T`
`visitVarReferenceListSub(SnpSiftParser.VarReferenceListSubContext ctx)`
Visit a parse tree produced by the `varReferenceListSub` labeled alternative in `SnpSiftParser.expression()`.

### Methods inherited from interface org.antlr.v4.runtime.tree.ParseTreeVisitor

`visit, visitChildren, visitErrorNode, visitTerminal`

## Method Details

### visitCompilationUnit

T visitCompilationUnit(SnpSiftParser.CompilationUnitContext ctx)
Visit a parse tree produced by `SnpSiftParser.compilationUnit()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitExpressionSet

T visitExpressionSet(SnpSiftParser.ExpressionSetContext ctx)
Visit a parse tree produced by the `expressionSet` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitLiteralString

T visitLiteralString(SnpSiftParser.LiteralStringContext ctx)
Visit a parse tree produced by the `literalString` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitExpressionUnary

T visitExpressionUnary(SnpSiftParser.ExpressionUnaryContext ctx)
Visit a parse tree produced by the `expressionUnary` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitExpressionComp

T visitExpressionComp(SnpSiftParser.ExpressionCompContext ctx)
Visit a parse tree produced by the `expressionComp` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitLiteralBool

T visitLiteralBool(SnpSiftParser.LiteralBoolContext ctx)
Visit a parse tree produced by the `literalBool` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitVarReferenceList

T visitVarReferenceList(SnpSiftParser.VarReferenceListContext ctx)
Visit a parse tree produced by the `varReferenceList` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitLiteralFloat

T visitLiteralFloat(SnpSiftParser.LiteralFloatContext ctx)
Visit a parse tree produced by the `literalFloat` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitLiteralIndex

T visitLiteralIndex(SnpSiftParser.LiteralIndexContext ctx)
Visit a parse tree produced by the `literalIndex` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitVarReference

T visitVarReference(SnpSiftParser.VarReferenceContext ctx)
Visit a parse tree produced by the `varReference` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitVarReferenceListSub

T visitVarReferenceListSub(SnpSiftParser.VarReferenceListSubContext ctx)
Visit a parse tree produced by the `varReferenceListSub` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitExpressionTimes

T visitExpressionTimes(SnpSiftParser.ExpressionTimesContext ctx)
Visit a parse tree produced by the `expressionTimes` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitExpressionExists

T visitExpressionExists(SnpSiftParser.ExpressionExistsContext ctx)
Visit a parse tree produced by the `expressionExists` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitExpressionPlus

T visitExpressionPlus(SnpSiftParser.ExpressionPlusContext ctx)
Visit a parse tree produced by the `expressionPlus` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitExpressionLogic

T visitExpressionLogic(SnpSiftParser.ExpressionLogicContext ctx)
Visit a parse tree produced by the `expressionLogic` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitFunctionCall

T visitFunctionCall(SnpSiftParser.FunctionCallContext ctx)
Visit a parse tree produced by the `functionCall` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitExpressionParen

T visitExpressionParen(SnpSiftParser.ExpressionParenContext ctx)
Visit a parse tree produced by the `expressionParen` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitExpressionCond

T visitExpressionCond(SnpSiftParser.ExpressionCondContext ctx)
Visit a parse tree produced by the `expressionCond` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result

### visitLiteralInt

T visitLiteralInt(SnpSiftParser.LiteralIntContext ctx)
Visit a parse tree produced by the `literalInt` labeled alternative in `SnpSiftParser.expression()`.

Parameters:
  `ctx` - the parse tree
Returns:
  the visitor result